const path = require('path');

module.exports = {
  stories: ['../projects/**/*.stories.ts'],
  addons: [
    '@storybook/addon-actions',
    '@storybook/addon-links',
    '@storybook/addon-notes',
    '@storybook/addon-knobs'
  ],
  webpackFinal: async (config) => {
    for (const rule of config.module.rules) {
      if (-1 < String(rule.test).indexOf('scss')) {
        rule.use.push({
          loader: 'sass-resources-loader',
          options: {
            resources: [path.join(__dirname, 'styles.scss')]
          }
        });
      }
    }

    return config;
  }
};
