import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/api-prompt';

import { _MODULE_CONFIG } from './config/token';

import { CallService } from './services/call.service';
import { ConferenceService } from './services/conference.service';

const SERVICES = [CallService, ConferenceService];

@NgModule({})
export class PromptApiRootModule {}

@NgModule({})
export class PromptApiModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<PromptApiRootModule> {
    return {
      ngModule: PromptApiRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
