import { createFeatureSelector, createSelector } from '@ngrx/store';

import * as CommonState from './common/state';
import * as GroupState from './group/state';
import * as BuddyState from './buddy/state';

export const KEY_FEATURE = 'group';

export interface State {
  common: CommonState.State;
  group: GroupState.State;
  buddy: BuddyState.State;
}

export const Selector = createFeatureSelector<State>(KEY_FEATURE);

export const CommonSelector = CommonState.selectors(
  createSelector(Selector, (state: State) => state.common)
);

export const GroupSelector = GroupState.selectors(
  createSelector(Selector, (state: State) => state.group)
);

export const BuddySelector = BuddyState.selectors(
  createSelector(Selector, (state: State) => state.buddy)
);
