import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FlexLayoutModule } from '@angular/flex-layout';

import { ScrollingModule } from '@angular/cdk/scrolling';

import { MatRippleModule } from '@angular/material/core';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatButtonModule } from '@angular/material/button';
import { MatIconModule } from '@angular/material/icon';
import { MatTreeModule } from '@angular/material/tree';

import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';

import { UiModule } from '@ucap/ng-ui';

import { ModuleConfig } from './config/module-config';
import { _MODULE_CONFIG } from './config/token';

import {
  ExpansionComponent,
  ExpansionNodeDirective,
  ExpansionFavoriteHeaderDirective,
  ExpansionBuddyHeaderDirective,
  ExpansionDefaultHeaderDirective
} from './components/expansion.component';

const COMPONENTS = [ExpansionComponent];
const DIALOGS = [];
const PIPES = [];
const DIRECTIVES = [
  ExpansionNodeDirective,
  ExpansionFavoriteHeaderDirective,
  ExpansionBuddyHeaderDirective,
  ExpansionDefaultHeaderDirective
];
const SERVICES = [];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class GroupUiRootModule {}

@NgModule({
  imports: [
    CommonModule,

    FlexLayoutModule,
    ScrollingModule,

    MatButtonModule,
    MatCheckboxModule,
    MatIconModule,
    MatRippleModule,
    MatTreeModule,

    PerfectScrollbarModule,
    UiModule
  ],
  exports: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  declarations: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  entryComponents: [...DIALOGS]
})
export class GroupUiModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<GroupUiRootModule> {
    return {
      ngModule: GroupUiRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
