import { storiesOf, moduleMetadata } from '@storybook/angular';
import { withKnobs, text, object } from '@storybook/addon-knobs';

import { action } from '@storybook/addon-actions';
import { linkTo } from '@storybook/addon-links';

import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

import { UiModule } from '../ui.module';

import { FloatActionButtonComponent } from './float-action-button.component';

export default {
  title: 'FloatActionButtonComponent',
  component: FloatActionButtonComponent,
  decorators: [
    moduleMetadata({
      imports: [BrowserModule, BrowserAnimationsModule, UiModule],
      providers: []
    })
  ]
};

export const Text = () => ({
  props: {
    buttons: object('Buttons', [
      {
        icon: 'chat',
        tooltip: 'tooltip_chat',
        divisionType: 'div_chat'
      },
      {
        icon: 'group',
        tooltip: 'tooltip_group',
        divisionType: 'div_group'
      }
    ]),
    buttonClick: (e) => {
      console.log(e);
      action('buttonClick')(e);
    }
  }
});
